#include <sys/types.h>
#include <pwd.h>
#include <grp.h>
#include "auto_uids.h"

void get_real_ids(void)
{
    auto_uida = get_real_uid(auto_uida_name);
    auto_uidd = get_real_uid(auto_uidd_name);
    auto_uidl = get_real_uid(auto_uidl_name);
    auto_uido = get_real_uid(auto_uido_name);
    auto_uidp = get_real_uid(auto_uidp_name);
    auto_uidq = get_real_uid(auto_uidq_name);
    auto_uidr = get_real_uid(auto_uidr_name);
    auto_uids = get_real_uid(auto_uids_name);

    auto_gidn = get_real_uid(auto_gidn_name);
    auto_gidq = get_real_uid(auto_gidq_name);
}

int get_real_gid(const char *name)
{
    struct group *ptr = 0;
    int system_id = 0;

    if (name != 0)
    {
        ptr = getgrnam(name);
        if (ptr != 0)
        {
            system_id = ptr->gr_gid;
        }
        else
        {
            system_id = 0;
        }
    }

    return system_id;
}

int get_real_uid(const char *name)
{
    int system_id = 0;
    struct passwd *ptr = 0;

    if (name != 0)
    {
        ptr = getpwnam(name);
        if (ptr != 0)
        {
            system_id = ptr->pw_uid;
        }
        else
        {
            system_id = 0;
        }
    }

    return system_id;
}
